using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using HidGlobal.MultiIso.CFReader;

namespace HID_Demo
{
    public partial class DemoForm : Form
    {
        ConnectForm connectform;
        AboutForm about;
        HID_CFReader reader;
        public DemoForm()
        {
            InitializeComponent();
            reader = new HID_CFReader();
            about = new AboutForm(reader);
            connectform = new ConnectForm(reader);
            
        }

        private void menuItem2_Click(object sender, EventArgs e)
        {
            
            if (menuItem2.Text == "Disconnect")
            {
                menuItem2.Text = "Connect";
                reader.RDR_CloseReader();
                reader.RDR_CloseComm();
            }
            else
            {
                
                connectform.ShowDialog();
                String portName = "";
                if (connectform.textBox1.Text=="COM")
                    return;
                portName = connectform.textBox1.Text;
                byte AutoSelected=Convert.ToByte(connectform.checkBox1.Checked);
                HID_CFReader.presetSettings settings;
                settings.baudRate=Convert.ToInt32(connectform.comboBox2.SelectedItem.ToString());
                settings.protocol=Convert.ToInt32(connectform.radioButton1.Checked);
                if(reader.RDR_OpenSingle(portName, AutoSelected, 0, settings)==1)
                    menuItem2.Text = "Disconnect";
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            //cont read
            reader.RDR_SendCommand("C", "");
            timer1.Enabled = true;
            reader.RDR_SetCommContRcv(1); 
            
        }

        private void button4_Click(object sender, EventArgs e)
        {
            
            reader.RDR_SendCommand(".", "");
            reader.RDR_AbortContinuousRead();
            reader.RDR_EmptyCommRcvBuffer();
            timer1.Enabled = false;
            
        }

        private void menuItem5_Click(object sender, EventArgs e)
        {
            about.ShowDialog();
        }

        private void menuItem3_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //Get Reader Info
            String ReaderType = "";
            String DeviceID = "";
            reader.RDR_GetReaderType(ref ReaderType);
            listBox1.Items.Add("ReaderType: " + ReaderType);
            reader.RDR_GetDeviceID(ref DeviceID);
            listBox1.Items.Add("Device ID: " + DeviceID);
            listBox1.Items.Add("Station ID: " + reader.RDR_GetStationID());
            SuccessSign.Visible = true;

        }

        private void button2_Click(object sender, EventArgs e)
        {
            String OutPut = "";
            reader.RDR_SendCommandGetData("select", "", ref OutPut);
            listBox1.Items.Add("" + OutPut);
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            if (reader.RDR_GetCommContRcv() == 1)
            {
                String ReadData = "";
                reader.RDR_GetData(ref ReadData);
                if(ReadData!="")
                {
                    listBox1.Items.Add(ReadData.Substring(1,ReadData.Length-3));
                    SuccessSign.Visible = true;
                }
                else
                {
                    ErrorSign.Visible = true;
                    SuccessSign.Visible = false;
                }
               
            }
        }

        private void menuItem7_Click(object sender, EventArgs e)
        {
            listBox1.Items.Clear();
        }

       
    }
}