// CFReaderDll_Demo_MFCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CFReaderDll_Demo_MFC.h"
#include "CFReaderDll_Demo_MFCDlg.h"
#include "ReaderDll.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CCFReaderDll_Demo_MFCDlg dialog

CCFReaderDll_Demo_MFCDlg::CCFReaderDll_Demo_MFCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCFReaderDll_Demo_MFCDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCFReaderDll_Demo_MFCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_PORT, m_edtPort);
	DDX_Control(pDX, IDC_BAUDRATE, m_edtBaudrate);
	DDX_Control(pDX, IDC_RDOASCII, m_rdoAscii);
	DDX_Control(pDX, IDC_BINARY, m_rdoBinary);
	DDX_Control(pDX, IDC_CHKAUTO, m_chkAuto);
	DDX_Control(pDX, IDC_LOG, m_edtLog);
	
}

BEGIN_MESSAGE_MAP(CCFReaderDll_Demo_MFCDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_CONNECT, &CCFReaderDll_Demo_MFCDlg::OnBnClickedConnect)
	
	ON_BN_CLICKED(IDC_CONNECT2, &CCFReaderDll_Demo_MFCDlg::OnBnClickedConnect2)
	ON_BN_CLICKED(IDC_READ, &CCFReaderDll_Demo_MFCDlg::OnBnClickedRead)
END_MESSAGE_MAP()


// CCFReaderDll_Demo_MFCDlg message handlers

BOOL CCFReaderDll_Demo_MFCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	m_edtPort.ReplaceSel(L"Com1");
m_edtBaudrate.ReplaceSel(L"9600");
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

#ifdef WIN32_PLATFORM_WFSP
	if (!m_dlgCommandBar.Create(this) ||
	    !m_dlgCommandBar.InsertMenuBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create CommandBar\n");
		return FALSE;      // fail to create
	}
#endif // WIN32_PLATFORM_WFSP
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CCFReaderDll_Demo_MFCDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_CFREADERDLL_DEMO_MFC_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_CFREADERDLL_DEMO_MFC_DIALOG));
	}
}
#endif


void CCFReaderDll_Demo_MFCDlg::OnBnClickedConnect()
{
	CString strPort=L"";
	m_edtPort.GetWindowText(strPort);
	if(strPort.IsEmpty())
		strPort=L"com1";
	CString strBaudrate=L"";
	m_edtBaudrate.GetWindowText(strBaudrate);
	if(strBaudrate.IsEmpty())
		strBaudrate=L"9600";
	presetSettings psSettings;
	psSettings.baudRate=_wtoi(strBaudrate.GetBuffer());
	psSettings.protocol=(int)(m_rdoBinary.GetCheck()==BST_CHECKED);
	short int sKnownReader=0;
	char szportName[10]={0};
		wcstombs(szportName,strPort.GetBuffer(),strPort.GetLength());
	if(RDR_OpenSingle(szportName,(char)(m_chkAuto.GetCheck()==BST_CHECKED),sKnownReader,&psSettings)==1){
	m_edtLog.ReplaceSel(L"Connected",1);
	m_edtLog.ReplaceSel(L"\r\n",1);
	char pReader[100]={0};
	RDR_GetReaderType(pReader);
	m_edtLog.ReplaceSel(CString(pReader));
	m_edtLog.ReplaceSel(L"\r\n",1);
	readerConfig config=	RDR_GetReaderConfig();
	CString Temp;
	Temp.Format(L"BaudRate=%d, Protocol=%d,Station Id=%d",config.baudRate,config.protocol,config.stationID);
	m_edtLog.ReplaceSel(Temp);
	}else{
	m_edtLog.ReplaceSel(L"unable to connect",1);
	}

}


void CCFReaderDll_Demo_MFCDlg::OnBnClickedConnect2()
{
	RDR_CloseReader();
	RDR_CloseComm();
	m_edtLog.ReplaceSel(L"\r\n Disconnected",1);
}

void CCFReaderDll_Demo_MFCDlg::OnBnClickedRead()
{
	char pData[MAX_PATH]={0};
	unsigned int len=0;
	RDR_AbortContinuousReadExt();
	RDR_EmptyCommRcvBuffer();
	RDR_SendCommandGetData2("select",pData,len,pData,&len);
	if(len>0){
		CString temp=L"";
		int i=0;
		m_edtLog.ReplaceSel(L"\r\n");
		while(len--!=0){
			temp.Format(L"%2X ",pData[i++]);
			m_edtLog.ReplaceSel(temp);
		}	
	}
}
