// CFreader_demo_win32.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "CFreader_demo_win32.h"
#include <windows.h>
#include <commctrl.h>
#include "ReaderDll.h"

#define MAX_LOADSTRING 100
#define ID_MYPROGRESS 100
// Global Variables:
HWND g_hwConnect=0,g_hwPort=0,g_hwBaudRate=0,g_hwPortlbl=0,g_hwBaudratelbl=0,g_hwChkAuto=0,g_hwrdoAscii=0,g_hwBinary=0;
HWND g_hwnMainDlg=0;
HWND g_hwnMain=0;

HINSTANCE			g_hInst;			// current instance
#ifdef SHELL_AYGSHELL
HWND				g_hWndMenuBar;		// menu bar handle
#else // SHELL_AYGSHELL
HWND				g_hWndCommandBar;	// command bar handle
#endif // SHELL_AYGSHELL

// Forward declarations of functions included in this code module:
ATOM			MyRegisterClass(HINSTANCE, LPTSTR);
BOOL			InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
#ifndef WIN32_PLATFORM_WFSP
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK    MainDlg(HWND , UINT, WPARAM, LPARAM);
#endif // !WIN32_PLATFORM_WFSP

int WINAPI WinMain(HINSTANCE hInstance,
				   HINSTANCE hPrevInstance,
				   LPTSTR    lpCmdLine,
				   int       nCmdShow)
{
	MSG msg;

	// Perform application initialization:
	if (!InitInstance(hInstance, nCmdShow)) 
	{
		return FALSE;
	}

#ifndef WIN32_PLATFORM_WFSP
	HACCEL hAccelTable;
	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_CFREADER_DEMO_WIN32));
#endif // !WIN32_PLATFORM_WFSP

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
#ifndef WIN32_PLATFORM_WFSP
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
#endif // !WIN32_PLATFORM_WFSP
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}

//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szWindowClass)
{
	WNDCLASS wc;

	wc.style         = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc   = WndProc;
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 0;
	wc.hInstance     = hInstance;
	wc.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_CFREADER_DEMO_WIN32));
	wc.hCursor       = 0;
	wc.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName  = 0;
	wc.lpszClassName = szWindowClass;

	return RegisterClass(&wc);
}

//
//   FUNCTION: InitInstance(HINSTANCE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	HWND hWnd;
	TCHAR szTitle[MAX_LOADSTRING];		// title bar text
	TCHAR szWindowClass[MAX_LOADSTRING];	// main window class name

	g_hInst = hInstance; // Store instance handle in our global variable

#if defined(WIN32_PLATFORM_PSPC) || defined(WIN32_PLATFORM_WFSP)
	// SHInitExtraControls should be called once during your application's initialization to initialize any
	// of the device specific controls such as CAPEDIT and SIPPREF.
	SHInitExtraControls();
#endif // WIN32_PLATFORM_PSPC || WIN32_PLATFORM_WFSP

	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING); 
	LoadString(hInstance, IDC_CFREADER_DEMO_WIN32, szWindowClass, MAX_LOADSTRING);

#if defined(WIN32_PLATFORM_PSPC) || defined(WIN32_PLATFORM_WFSP)
	//If it is already running, then focus on the window, and exit
	hWnd = FindWindow(szWindowClass, szTitle);	
	if (hWnd) 
	{
		// set focus to foremost child window
		// The "| 0x00000001" is used to bring any owned windows to the foreground and
		// activate them.
		SetForegroundWindow((HWND)((ULONG) hWnd | 0x00000001));
		return 0;
	} 
#endif // WIN32_PLATFORM_PSPC || WIN32_PLATFORM_WFSP

	if (!MyRegisterClass(hInstance, szWindowClass))
	{
		return FALSE;
	}
	g_hwnMainDlg=(HWND)DialogBox(g_hInst, (LPCTSTR)IDD_MAINDLG, hWnd, MainDlg);
	return TRUE;
}

//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

#if defined(SHELL_AYGSHELL) && !defined(WIN32_PLATFORM_WFSP)
	static SHACTIVATEINFO s_sai;
#endif // SHELL_AYGSHELL && !WIN32_PLATFORM_WFSP

	switch (message) 
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam); 
		wmEvent = HIWORD(wParam); 
		// Parse the menu selections:
		switch (wmId)
		{
#ifndef WIN32_PLATFORM_WFSP
	case IDM_HELP_ABOUT:
		DialogBox(g_hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, About);
		break;
#endif // !WIN32_PLATFORM_WFSP
#ifndef SHELL_AYGSHELL
	case IDM_FILE_EXIT:
		DestroyWindow(hWnd);
		break;
#endif // !SHELL_AYGSHELL
#ifdef WIN32_PLATFORM_WFSP
	case IDM_OK:
		DestroyWindow(hWnd);
		break;
#endif // WIN32_PLATFORM_WFSP
#ifdef WIN32_PLATFORM_PSPC
	case IDM_OK:
		SendMessage (hWnd, WM_CLOSE, 0, 0);				
		break;
#endif // WIN32_PLATFORM_PSPC
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_CREATE:
		g_hwnMainDlg=(HWND)DialogBox(g_hInst, (LPCTSTR)IDD_MAINDLG, hWnd, MainDlg);
		if(g_hwnMainDlg!=NULL)
			ShowWindow(g_hwnMainDlg,SW_SHOW);
#ifndef SHELL_AYGSHELL
		g_hWndCommandBar = CommandBar_Create(g_hInst, hWnd, 1);
		CommandBar_InsertMenubar(g_hWndCommandBar, g_hInst, IDR_MENU, 0);
		CommandBar_AddAdornments(g_hWndCommandBar, 0, 0);
#endif // !SHELL_AYGSHELL
#ifdef SHELL_AYGSHELL
		SHMENUBARINFO mbi;

		memset(&mbi, 0, sizeof(SHMENUBARINFO));
		mbi.cbSize     = sizeof(SHMENUBARINFO);
		mbi.hwndParent = hWnd;
		mbi.nToolBarId = IDR_MENU;
		mbi.hInstRes   = g_hInst;

		if (!SHCreateMenuBar(&mbi)) 
		{
			g_hWndMenuBar = NULL;
		}
		else
		{
			g_hWndMenuBar = mbi.hwndMB;
		}

#ifndef WIN32_PLATFORM_WFSP
		// Initialize the shell activate info structure
		memset(&s_sai, 0, sizeof (s_sai));
		s_sai.cbSize = sizeof (s_sai);
#endif // !WIN32_PLATFORM_WFSP
#endif // SHELL_AYGSHELL
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);

		// TODO: Add any drawing code here...

		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
#ifndef SHELL_AYGSHELL
		CommandBar_Destroy(g_hWndCommandBar);
#endif // !SHELL_AYGSHELL
#ifdef SHELL_AYGSHELL
		CommandBar_Destroy(g_hWndMenuBar);
#endif // SHELL_AYGSHELL
		PostQuitMessage(0);
		break;

#if defined(SHELL_AYGSHELL) && !defined(WIN32_PLATFORM_WFSP)
	case WM_ACTIVATE:
		// Notify shell of our activate message
		SHHandleWMActivate(hWnd, wParam, lParam, &s_sai, FALSE);
		break;
	case WM_SETTINGCHANGE:
		SHHandleWMSettingChange(hWnd, wParam, lParam, &s_sai);
		break;
#endif // SHELL_AYGSHELL && !WIN32_PLATFORM_WFSP

	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

#ifndef WIN32_PLATFORM_WFSP
//Callback procedure for Main dialog.
//
INT_PTR CALLBACK MainDlg(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam){
	switch (message)
	{
	case WM_INITDIALOG:
		SetDlgItemText(hDlg,IDC_PORT,L"Com1");
		SetDlgItemText(hDlg,IDC_BAUDRATE,L"9600");
		SendMessage(GetDlgItem(hDlg,IDC_RADIO2),BM_SETCHECK,(WPARAM)BST_CHECKED,0);
		break;
	case WM_COMMAND:
		{
			switch(LOWORD(wParam) )
			{
			/*Used to connect & Get reader info*/
			case IDCONNECT://Used to get Connected..
				{
					WCHAR szwportname[10]={0};
					WCHAR szwBaudRate[100]={0};
					GetDlgItemText(hDlg,IDC_PORT,szwportname,10);
					char szportName[10]={0};
					wcstombs(szportName,szwportname,wcslen(szwportname));
					GetDlgItemText(hDlg,IDC_BAUDRATE,szwBaudRate,10);
					presetSettings psSettings;
					psSettings.baudRate=_wtoi(szwBaudRate);
					psSettings.protocol=(char)(HRESULT)SendMessage(GetDlgItem(hDlg,IDC_RADIO1),BM_GETCHECK,0,0);
					
					//Try to open virtual comport and reader.
					if(RDR_OpenSingle(szportName,SendMessage(GetDlgItem(hDlg,IDC_CHECK1),BM_GETCHECK,0,0),0,&psSettings)){
						LRESULT lRet=SendMessage(GetDlgItem(hDlg,IDC_LOG),EM_REPLACESEL ,(WPARAM) true,(LPARAM) (LPCTSTR) L"Connected\r\n");
						char szreader[100]={0};
						//Getting reader information of successfull connection.
						RDR_GetReaderType(szreader);
						ZeroMemory(szwportname,100);
						mbstowcs(szwportname,szreader,strlen(szreader));
						lRet=SendMessage(GetDlgItem(hDlg,IDC_LOG),EM_REPLACESEL ,(WPARAM) true,(LPARAM) (LPCTSTR) szwportname);
						//getting reader connection information.
						readerConfig config=RDR_GetReaderConfig();
						ZeroMemory(szwportname,100);
						wsprintf(szwportname,L"\r\nConnected at Baudrate=%d,\r\nProtocol=%d,Station ID=%d\r\n",config.baudRate,config.protocol,config.stationID);
						SendMessage(GetDlgItem(hDlg,IDC_LOG),EM_REPLACESEL ,(WPARAM) true,(LPARAM) (LPCTSTR) szwportname);

					}else{
						SendMessage(GetDlgItem(hDlg,IDC_LOG),EM_REPLACESEL ,(WPARAM) true,(LPARAM) (LPCTSTR) L"\r\nUnable to connect");
						return (INT_PTR)FALSE;
					}
				}
				break;
			case IDDISCONNECT://Used to disconnect reader.
				//closing reader	
				RDR_CloseReader();
				//Closing communication port.
				RDR_CloseComm();
				SendMessage(GetDlgItem(hDlg,IDC_LOG),EM_REPLACESEL ,(WPARAM) true,(LPARAM) (LPCTSTR) L"Disconnect..\r\n");
				break;
			case IDREAD:
				{
					//Try to read some thing from communication port.
					RDR_AbortContinuousReadExt();//if protocol is Ascii then continuous read is ON automatically so turing that OFF.
					RDR_EmptyCommRcvBuffer();//Clearing all garbage.
					char pData[MAX_PATH]={0};
					unsigned int len=0;
					//sending select command to read SNo of card presented.
					RDR_SendCommandGetData2("select",pData,len,pData,&len);
					if(len==0)
						return (INT_PTR)false;
					SendMessage(GetDlgItem(hDlg,IDC_LOG),EM_REPLACESEL ,(WPARAM) true,(LPARAM) (LPCTSTR) L"\r\n");
					if(RDR_GetCommProtocol()==1){
						WCHAR wszResponse[2];
						int i=0;
						while(len--!=0){
							wsprintf(wszResponse,L"%2X ",pData[i++]);
							SendMessage(GetDlgItem(hDlg,IDC_LOG),EM_REPLACESEL ,(WPARAM) true,(LPARAM) (LPCTSTR) wszResponse);
						}
					}else{
						WCHAR szwportname[100]={0};
						ZeroMemory(szwportname,100);
						mbstowcs(szwportname,pData,strlen(pData));
						SendMessage(GetDlgItem(hDlg,IDC_LOG),EM_REPLACESEL ,(WPARAM) true,(LPARAM) (LPCTSTR) szwportname);

					}
				}
				break;
			case IDCANCEL:
				EndDialog(hDlg, LOWORD(wParam));
				PostQuitMessage(0);
				return (INT_PTR)TRUE;
				break;
			case IDABOUT:
				DialogBox(g_hInst, (LPCTSTR)IDD_ABOUTBOX, hDlg, About);
				break;
			}
		}
		break;
	}
	return (INT_PTR)FALSE;
}
// Message handler for about box.
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
#ifndef SHELL_AYGSHELL
		RECT rectChild, rectParent;
		int DlgWidth, DlgHeight;	// dialog width and height in pixel units
		int NewPosX, NewPosY;

		// trying to center the About dialog
		if (GetWindowRect(hDlg, &rectChild)) 
		{
			GetClientRect(GetParent(hDlg), &rectParent);
			DlgWidth	= rectChild.right - rectChild.left;
			DlgHeight	= rectChild.bottom - rectChild.top ;
			NewPosX		= (rectParent.right - rectParent.left - DlgWidth) / 2;
			NewPosY		= (rectParent.bottom - rectParent.top - DlgHeight) / 2;

			// if the About box is larger than the physical screen 
			if (NewPosX < 0) NewPosX = 0;
			if (NewPosY < 0) NewPosY = 0;
			SetWindowPos(hDlg, 0, NewPosX, NewPosY,
				0, 0, SWP_NOZORDER | SWP_NOSIZE);
		}
#endif // !SHELL_AYGSHELL
#ifdef SHELL_AYGSHELL
		{
			// Create a Done button and size it.  
			SHINITDLGINFO shidi;
			shidi.dwMask = SHIDIM_FLAGS;
			shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN | SHIDIF_EMPTYMENU;
			shidi.hDlg = hDlg;
			SHInitDialog(&shidi);
		}
#endif // SHELL_AYGSHELL

		return (INT_PTR)TRUE;

	case WM_COMMAND:
#ifndef SHELL_AYGSHELL
		if ((LOWORD(wParam) == IDOK) || (LOWORD(wParam) == IDCANCEL))
#endif // !SHELL_AYGSHELL
#ifdef SHELL_AYGSHELL
			if (LOWORD(wParam) == IDOK)
#endif
			{
				EndDialog(hDlg, LOWORD(wParam));
				return (INT_PTR)TRUE;
			}
			break;

	case WM_CLOSE:
		EndDialog(hDlg, message);
		return (INT_PTR)TRUE;

	}
	return (INT_PTR)FALSE;
}
#endif // !WIN32_PLATFORM_WFSP
