using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.IO.Ports;
using System.Windows.Forms;
using ReaderDllWrapper;
namespace ReaderDll_Demo_CS
{
    
    public partial class Form1 : Form
    {
        private HID_Reader reader = new HID_Reader();
        private IntPtr m_IPComm;
        private IntPtr m_IPReader;
        
        public Form1()
        {
            InitializeComponent();
        }
        /**
         Use to perform connect and disconnect
         */
        private void button1_Click(object sender, EventArgs e)
        {
            //Connect
            if (button1.Text == "Connect")
            {
                HID_Reader.presetSettings ps = new HID_Reader.presetSettings();
                if (checkBox1.CheckState != CheckState.Checked)
                {
                    ps.baudRate = Convert.ToInt32(BaudRateName.Text);
                    ps.protocol = cmbProtocol.SelectedIndex;//0 for ascii, 1 for Binary.
                }
                m_IPComm = reader.RDR_OpenComm(ComPortName.Text, Convert.ToByte(checkBox1.CheckState), ps);
                if (m_IPComm.ToInt32() == 0)
                {
                    MessageBox.Show("Sorry unable to Open com port");
                    return;
                }
                else
                {
                    tb1.Text = tb1.Text + "Connected successfully" + "\r\n";

                }
                button1.Text = "Disconnect";
                short sReader = 0;
                m_IPReader = reader.RDR_OpenReader(m_IPComm, 1, sReader);
                reader.RDR_SendCommand(m_IPReader, "continuous read", "");
                reader.RDR_SendCommand(m_IPReader, "select", "");
                timer1.Enabled = true;
            }
            else
            {   //Disconnect
                timer1.Enabled = false;
                
                reader.RDR_AbortContinuousRead(m_IPComm);
                reader.RDR_CloseReader(m_IPReader);
                reader.RDR_CloseComm(m_IPComm);
                button1.Text = "Connect";
            }
        }
        /*
         * Use to perform Initialize Pom port lists.
         */
        private void Form1_Load(object sender, EventArgs e)
        {
            string[] str =SerialPort.GetPortNames();            
            foreach (string s in str)
            {
            ComPortName.Items.Add(s);
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            string str="";
            reader.RDR_GetData(m_IPReader, ref str);
            if(str!=""){
                tb1.Text = tb1.Text + str+"\r\n";
               //Clearing buffer
                reader.RDR_EmptyCommRcvBuffer(m_IPComm);
                //sends select command for card to be selected..
                reader.RDR_SendCommand(m_IPReader, "select", "");
            }

        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            //Checking for states
            if (checkBox1.CheckState != CheckState.Checked)
            {
                cmbProtocol.Enabled = true;
                cmbProtocol.SelectedIndex = 0;
                BaudRateName.Enabled = true;
                BaudRateName.SelectedIndex = 0;
            }else
            {
                cmbProtocol.Enabled = false;
                BaudRateName.Enabled = false;
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            About ab = new About();
            ab.ShowDialog(this);
            string s = BaudRateName.Text;
            tb1.Text = "";
        }
    }
}
