// ConnectionSettingsPage.cpp : implementation file
//

#include "stdafx.h"
#include "ReaderDll_demo.h"




// CConnectionSettingsPage dialog

IMPLEMENT_DYNAMIC(CConnectionSettingsPage, CPropertyPage)

CConnectionSettingsPage::CConnectionSettingsPage()
	: CPropertyPage(CConnectionSettingsPage::IDD)
{

}

CConnectionSettingsPage::~CConnectionSettingsPage()
{
}

void CConnectionSettingsPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CConnectionSettingsPage, CPropertyPage)
	ON_BN_CLICKED(IDC_CONNECT, &CConnectionSettingsPage::OnBnClickedConnect)
	ON_BN_CLICKED(IDC_REFRESH, &CConnectionSettingsPage::OnBnClickedRefresh)
	ON_BN_CLICKED(IDC_CHK_AUTO_DETECT, &CConnectionSettingsPage::OnBnClickedChkAutoDetect)
END_MESSAGE_MAP()


// CConnectionSettingsPage message handlers

BOOL CConnectionSettingsPage::OnInitDialog()
	{
	CPropertyPage::OnInitDialog();

	// TODO:  Add extra initialization here
	CString szTemp;
	szTemp.LoadString(IDS_PORTNAME);
	SetDlgItemText(IDC_PORTNAME,szTemp);
	szTemp.LoadString(IDS_PROTOCOL);
	SetDlgItemText(IDC_PROTOCOL,szTemp);
	szTemp.LoadString(IDS_BAUDRATE);
	SetDlgItemText(IDC_BUADRATE,szTemp);
	szTemp.LoadString(IDS_CHK_AUTO_DETECT);
	SetDlgItemText(IDC_CHK_AUTO_DETECT,szTemp);
	szTemp.LoadString(IDS_CONNECT);
	SetDlgItemText(IDC_CONNECT,szTemp);
	RefreshPorts();
	((CButton*)GetDlgItem(IDC_CHK_AUTO_DETECT))->SetCheck(BST_CHECKED);
	GetDlgItem(IDC_CMB_BUADRATE)->EnableWindow(false);
	GetDlgItem(IDC_CMB_PROTOCOL)->EnableWindow(false);
	SetBaudRates();

	SetProtocols();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
	}

void CConnectionSettingsPage::OnBnClickedConnect()
	{
	//Used to connect to available reader at some specific port.
	CString szTemp;
	CString szPortName=L"";
	szTemp.LoadString(IDS_DISCONNECT);
	GetDlgItemText(IDC_CONNECT,szPortName);
	if(szTemp.CompareNoCase(szPortName)==0){
			RDR_CloseReader(theApp.m_hReader);
			RDR_CloseComm(theApp.m_hCom);
		//CloseHandle(theApp.m_hCom);
		//	CloseHandle(theApp.m_hReader);
			theApp.m_hCom=NULL;
			szTemp.LoadString(IDS_CONNECT);
			SetDlgItemText(IDC_CONNECT,szTemp);
			theApp.m_Logpage->AddLog(L"Disconnect Ok");
			theApp.m_Logpage->GetDlgItem(IDC_SAVE)->EnableWindow(false);

		return ;
		}

	theApp.m_Logpage->AddLog(L"Try to Connect");
	((CComboBox*)GetDlgItem(IDC_CMB_PORTNAME))->GetLBText(((CComboBox*)GetDlgItem(IDC_CMB_PORTNAME))->GetCurSel(),szPortName);
	bool blAutoDetect=((CButton*)GetDlgItem(IDC_CHK_AUTO_DETECT))->GetCheck()==BST_CHECKED;
	presetSettings ps;
	CString szBaudRate=L"9600";
	((CComboBox*)GetDlgItem(IDC_CMB_BUADRATE))->GetLBText(((CComboBox*)GetDlgItem(IDC_CMB_BUADRATE))->GetCurSel(),szBaudRate);
	ps.baudRate=_wtol(szBaudRate.GetBuffer());
	ps.protocol=((CComboBox*)GetDlgItem(IDC_CMB_PROTOCOL))->GetCurSel();
	char pchPortName[100]={0};
	wcstombs(pchPortName,szPortName.GetBuffer(),szPortName.GetLength());
	RDR_SetCommTimeout(theApp.m_hCom, 100);
	//Connecting to port..
	theApp.m_hCom=RDR_OpenComm(pchPortName,blAutoDetect,&ps);
	if(!theApp.m_hCom){
		theApp.m_Logpage->AddLog(L"Unable to connect");
		return ;
		}
	char pcVersion[100]={0};
	//Detecting reader..
	RDR_DetectReader(theApp.m_hCom,pcVersion);
	theApp.m_hReader=	RDR_OpenReader(theApp.m_hCom,pcVersion[0],0);
	if(!theApp.m_hReader){
		theApp.m_Logpage->AddLog(L"Unable to Open Reader");
		RDR_CloseComm(theApp.m_hCom);
		return ;
		}
	ZeroMemory(pcVersion,100);
	//Sending version command to get firmware version..
	if(!RDR_SendCommandGetData(theApp.m_hReader,"Version",pcVersion,pcVersion) || !pcVersion[0] ){
		theApp.m_Logpage->AddLog(L"Unable get version information.");
		theApp.m_Logpage->AddLog(L"Conneted with limited capability.");
		szTemp.LoadString(IDS_DISCONNECT);
		SetDlgItemText(IDC_CONNECT,szTemp);
		return ;
		}
	theApp.m_Logpage->AddLog(CString(pcVersion));
	long baudrate=0;
	long protocol=0;
	if(blAutoDetect){
		baudrate=RDR_GetCommBaudRate(theApp.m_hCom);
		protocol=RDR_GetCommProtocol(theApp.m_hCom);
		CString str;
		str.Format(L"BuadRate=%d,protocol=%d",baudrate,protocol);
		theApp.m_Logpage->AddLog(str);
		}
	szTemp.LoadString(IDS_DISCONNECT);
	SetDlgItemText(IDC_CONNECT,szTemp);
	theApp.m_Logpage->AddLog(L"Connected successfully");
	theApp.m_Logpage->AddLog(CString(&pcVersion[1]));
		theApp.m_Logpage->GetDlgItem(IDC_SAVE)->EnableWindow(true);
	}

// used to refresh ports..
void CConnectionSettingsPage::RefreshPorts(void)
	{
	((CComboBox*)GetDlgItem(IDC_CMB_PORTNAME))->ResetContent();
	CString szPortName=L"";
	HANDLE m_SPHandle;
	for(int i=1;i<256;i++){
		szPortName.Format(L"COM%d",i);
		m_SPHandle=CreateFile(szPortName,GENERIC_READ | GENERIC_WRITE,0,NULL,OPEN_EXISTING,0, NULL);
		if(m_SPHandle != INVALID_HANDLE_VALUE)
			{
			((CComboBox*)GetDlgItem(IDC_CMB_PORTNAME))->AddString(szPortName);
			}
		CloseHandle(m_SPHandle);
		}
	((CComboBox*)GetDlgItem(IDC_CMB_PORTNAME))->SetCurSel(0);
	}

void CConnectionSettingsPage::OnBnClickedRefresh()
	{
	RefreshPorts();
	}

void CConnectionSettingsPage::OnBnClickedChkAutoDetect()
	{
	if(((CButton*)GetDlgItem(IDC_CHK_AUTO_DETECT))->GetCheck()==BST_UNCHECKED){
		GetDlgItem(IDC_CMB_BUADRATE)->EnableWindow();
		GetDlgItem(IDC_CMB_PROTOCOL)->EnableWindow();
	}else
		{
		GetDlgItem(IDC_CMB_BUADRATE)->EnableWindow(false);
		GetDlgItem(IDC_CMB_PROTOCOL)->EnableWindow(false);
		}
	}

void CConnectionSettingsPage::SetBaudRates(void)
	{
	((CComboBox*)GetDlgItem(IDC_CMB_BUADRATE))->AddString(L"9600");
	((CComboBox*)GetDlgItem(IDC_CMB_BUADRATE))->AddString(L"14400");
	((CComboBox*)GetDlgItem(IDC_CMB_BUADRATE))->AddString(L"19200");
	((CComboBox*)GetDlgItem(IDC_CMB_BUADRATE))->AddString(L"38400");
	((CComboBox*)GetDlgItem(IDC_CMB_BUADRATE))->AddString(L"57600");
	((CComboBox*)GetDlgItem(IDC_CMB_BUADRATE))->AddString(L"115200");
	((CComboBox*)GetDlgItem(IDC_CMB_BUADRATE))->AddString(L"230400");
	((CComboBox*)GetDlgItem(IDC_CMB_BUADRATE))->AddString(L"460800");
	((CComboBox*)GetDlgItem(IDC_CMB_BUADRATE))->AddString(L"921600");
	((CComboBox*)GetDlgItem(IDC_CMB_BUADRATE))->SetCurSel(0);
	}

void CConnectionSettingsPage::SetProtocols(void)
	{
	((CComboBox*)GetDlgItem(IDC_CMB_PROTOCOL))->AddString(L"ANSI");
	((CComboBox*)GetDlgItem(IDC_CMB_PROTOCOL))->AddString(L"BINARY");
	((CComboBox*)GetDlgItem(IDC_CMB_PROTOCOL))->SetCurSel(0);
	}

