/////////////////////////////////////////////////////////////////////////////
//
// PROPRIETARY INFORMATION.  This document contains proprietary 
// information of HID Corporation which may not be reproduced, published 
// or disclosed to others.  This is demo software and should not be 
// considered a salable product.   The software is protected by intellectual 
// property law, copyright law, and international treaties.  
// 2006  HID Corporation. All rights reserved.
//
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
//
// class: CClock
//
// This class is responsible computer time tracking e.g. tracking operation time.
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "clock.h"

CClock::CClock( )
{
}

CClock::~CClock( )
{
}

/////////////////////////////////////////////////////////////////////////////
//
// Start
//
// Start the timer.
// PostCondition: StartTime is set to the current computer time.
//
////////////////////////////////////////////////////////////////////////////
void CClock::Start( )
{
endTick=0;
totalTick=0;
startTick=GetTickCount();
	StartTime = clock( );
	m_stwatch.startTimer();
}

/////////////////////////////////////////////////////////////////////////////
//
// End
//
// End the timer.
// PreCondition: Start has been called first.
// PostCondition: NowTime is set to the current computer time.  Duration holds the
// number of milliseconds between the NowTime and StartTime timestamps (duration
// calculation assums that NowTime is larger than StartTime).
//
////////////////////////////////////////////////////////////////////////////
void CClock::End( )
{
endTick=GetTickCount();
m_stwatch.stopTimer();
totalTick=endTick-startTick;
		NowTime = clock( );
	Duration = ( double )( NowTime - StartTime ) / CLOCKS_PER_SEC * 1000;
	Duration=totalTick;
}

CString CClock::GetSecMs( )
{
	/*SYSTEMTIME sysTime;
	CString time;
	GetLocalTime( &sysTime );
	time.Format(L"%02d.%03d", sysTime.wSecond, sysTime.wMilliseconds );
	return time;*/
	CString sztime;
	//if(!(int)m_stwatch.getElapsedTime()/1000)
		sztime.Format(L"%.06f",m_stwatch.getElapsedTime()*1000);
//	else
	return sztime;


}

CString CClock::GetFullTime( )
{
	SYSTEMTIME sysTime;
	CString time;
	GetLocalTime( &sysTime );
	time.Format( L"%02d:%02d:%02d.%03d", sysTime.wHour, sysTime.wMinute, sysTime.wSecond, sysTime.wMilliseconds );
	return time;
}