//struct readerConfig
//{
//  long baudRate;  
//  char protocol;  
//  unsigned char stationID;
//};
//
//struct presetSettings 
//{
//  long baudRate;  
//  char protocol;  
//};

// Opens and initializes a specified communication device and a reader at once. This function only works with one reader module.
char  __stdcall RDR_OpenSingle(void** hComm, void** hReader, char* commDevice, char autodetect, short knownReader, struct presetSettings* settings);

// Detect all available serial ports.
char  __stdcall RDR_DetectSerialPort(char* buffer, long buflength);

// Opens and initializes a specified communication device.
void* __stdcall RDR_OpenComm(char* commDevice, char autodetect, struct presetSettings* settings);

// Gives control of RTS and DTR pins of the specified communication device.
void  __stdcall RDR_CommExtFunction(void* hComm, long function);

// Closes and releases the communication device.
void  __stdcall RDR_CloseComm(void* hComm);

// Closes the communication device but does not release communication resources.
void  __stdcall RDR_SleepComm(void* hComm);

// Reopens the communication without allocating communication resources.
char  __stdcall RDR_WakeupComm(void* hComm);

// Returns the communication device handle of a given communication device.
void* __stdcall RDR_GetCommDeviceHandle(void* hComm);

// Empties the receive buffer of the communication.
void  __stdcall RDR_EmptyCommRcvBuffer(void* hComm);

// Aborts the continuous read command. (This function is obsolete, use RDR_AbortContinuousReadExt)
void  __stdcall RDR_AbortContinuousRead(void* hComm);

// Aborts the continuous read command.
void  __stdcall RDR_AbortContinuousReadExt(void* hReader);

// Sets and applies the transfer protocol of the communication device.
void  __stdcall RDR_SetCommProtocol(void* hComm, char protocol);

// Returns the active transfer protocol of the communication device.
char  __stdcall RDR_GetCommProtocol(void* hComm);

// Sets and applies the baud rate of the communication device.
void  __stdcall RDR_SetCommBaudRate(void* hComm, long bdRate);

// Gets the current baud rate of the communication device.
long  __stdcall RDR_GetCommBaudRate(void* hComm);

// Sets and applies the continuous receive mode of the commnication device.
void  __stdcall RDR_SetCommContRcv(void* hComm, char contReceiveMode);

// Returns the state of continuous receive mode.
char  __stdcall RDR_GetCommContRcv(void* hComm);

// Sets and applies the timeout of the communication device.
void  __stdcall RDR_SetCommTimeout(void* hComm, long timeout);

// Returns the timeout of the communication device.
long  __stdcall RDR_GetCommTimeout(void* hComm);

// Detects all available readers and devices on a specified communication device.
char* __stdcall RDR_DetectReader(void* hComm, char* buffer);

// Opens a reader on specified communication device with specified ID.
void* __stdcall RDR_OpenReader(void* hComm, unsigned char id, short knownReader);

// Closes a reader specified with its handle.
void  __stdcall RDR_CloseReader(void* hReader);

// Resets a reader specified with its handle.
void  __stdcall RDR_ResetReader(void* hReader);

// Sends a command to a reader specified with its handle. (This function is obsolete, use RDR_SendCommand2)
long  __stdcall RDR_SendCommand(void* hReader, char* command, char* data);

// Sends a command to a reader specified with its handle.
long __stdcall RDR_SendCommand2(void* hReader, char* command, char* data, unsigned int length);

// Receives data from a reader specified with its handle. (This function is obsolete, use RDR_GetData2)
char* __stdcall RDR_GetData(void* hReader, char* buffer);

// Receives data from a reader specified with its handle.
char* __stdcall RDR_GetData2(void* hReader, char* buffer, unsigned int* return_length);

// Sends a command to a reader specified with its handle and receives data. (This function is obsolete, use RDR_SendCommandGetData2)
char* __stdcall RDR_SendCommandGetData(void* hReader, char* command, char* data, char* buffer);

// Sends a command to a reader specified with its handle and receives data.
char* __stdcall RDR_SendCommandGetData2(void* hReader, char* command, char* data, unsigned int length, char* return_buffer, unsigned int* return_length);

// Receives data from a reader specified with its handle with timeout. (This function is obsolete, use RDR_GetDataTimeout2)
char* __stdcall RDR_GetDataTimeout(void* hReader, char* buffer, long timeout);

// Receives data from a reader specified with its handle with timeout. 
char* __stdcall RDR_GetDataTimeout2(void* hReader, char* buffer, unsigned int* return_length, long timeout);

// Sends a command to a reader specified with its handle and receives data with timeout. (This function is obsolete, use RDR_SendCommandGetDataTimeout2)
char* __stdcall RDR_SendCommandGetDataTimeout(void* hReader, char* command, char* data, char* buffer, long timeout);

// Sends a command to a reader specified with its handle and receives data with timeout.
char* __stdcall RDR_SendCommandGetDataTimeout2(void* hReader, char* command, char* data, unsigned int length, char* buffer, unsigned int* return_length, long timeout);

// Sets and applies the reader with specified configuration. The communication device even adapted to this new settings.
void  __stdcall RDR_SetReaderConfig(void* hReader, struct readerConfig* config);

// Returns current reader configuration.
struct readerConfig __stdcall RDR_GetReaderConfig(void* hReader);

// Returns the version string of a reader specified with its handle.
char* __stdcall RDR_GetReaderType(void* hReader, char* buffer);

// Returns the station ID of a reader specified with its handle.
unsigned char __stdcall RDR_GetStationID(void* hReader);

// Check if a script command is available for a reader specified with its handle.
char  __stdcall RDR_IsCommandAvailable(void* hReader, char* command);

// Returns the device ID of a reader specified with its handle.
char* __stdcall RDR_GetDeviceID(void* hReader, char* buffer);

// Activates/deactivates broadcast mode of binary protocol using a reader specified with its handle.
void  __stdcall RDR_SetBroadcast(void* hReader, char broadcast);

// Returns the state of broadcast mode of a reader specified with its handle.
char  __stdcall RDR_GetBroadcast(void* hReader);

// Returns the version of the DLL. (This function is obsolete, use GetDLLVersionStr)
long  __stdcall RDR_GetDLLVersion(void);

// Returns the version of the DLL as string.
char* __stdcall RDR_GetDLLVersionStr(char* buffer);

// Activates/deactivates debug output for a reader specified with its handle.
void  __stdcall RDR_SetDebugOutputState(void* hReader, char state);

// Returns the state of debug output for a reader specified with its handle.
char  __stdcall RDR_GetDebugOutputState(void* hReader);

// Returns the debug output for a reader specified with its handle.
char* __stdcall RDR_GetDebugOutput(void* hReader, char* buffer);

// Starts the timer for a reader specified with its handle.
void  __stdcall RDR_StartTimer(void* hReader);

// Returns the response time for a reader specified with its handle.
float __stdcall RDR_GetTiming(void* hReader);

// Returns the flag of the binary protocol v2 for a reader specified with its handle.
char  __stdcall RDR_GetBinFlag(void* hReader);

// Returns the used binary protocol type for a reader specified with its handle.
char  __stdcall RDR_GetBinProtocol(void* hReader);

// Prepares the firmware upload and checks the password.
long  __stdcall RDR_LoadFirmware(void* hReader, char* data, long length, char* password, char option);

// Initialize the firmware update.
void  __stdcall RDR_InitUpdateFirmware();

// Update one line of the firmware. Call this function until the upload is finished.
char  __stdcall RDR_UpdateFirmware(void* hReader);

// Encrypts data using DES algorithm. Data input and output buffer has to be different.
char* __stdcall RDR_DESEncrypt(char options, char* key, char* data, long length, char* output);

// Decrypts data using DES algorithm. Data input and output buffer has to be different.
char* __stdcall RDR_DESDecrypt(char options, char* key, char* data, long length, char* output);

// DESFire command set.
char* __stdcall RDR_DESFire(void* hReader, char command, char* data, char* output);

// Sets the timeout of the DESFire SAM.
void  __stdcall RDR_SetDESFireSAMTimeout(char timeout);

// Returns the timeout of the DESFire SAM.
char  __stdcall RDR_GetDESFireSAMTimeout();

// Paypass polling sequence
char  __stdcall RDR_Paypass_Polling(void* hReader);

// Paypass activation sequence
char  __stdcall RDR_Paypass_Activation(void* hReader);

// Paypass transaction sequence
char  __stdcall RDR_Paypass_Transaction(void* hReader, char* input, int length, char* output, int* outLen, int bufSize);

// Paypass deactivation sequence
char  __stdcall RDR_Paypass_Deactivate(void* hReader);

// DESFire and SAM definitions
#define DESFIRE_SAM_ON_OFF                0x00
#define DESFIRE_AUTHENICATE               0x01
#define DESFIRE_CHANGE_KEY_SETTINGS       0x02
#define DESFIRE_GET_KEY_SETTINGS          0x03
#define DESFIRE_CHANGE_KEY                0x04
#define DESFIRE_GET_KEY_VERSION           0x05
#define DESFIRE_CREATE_APPLICATION        0x06
#define DESFIRE_DELETE_APPLICATION        0x07
#define DESFIRE_GET_APPLICATION_IDS       0x08
#define DESFIRE_SELECT_APPLICATION        0x09
#define DESFIRE_FORMAT_PICC               0x0A
#define DESFIRE_GET_VERSION               0x0B
#define DESFIRE_GET_FILE_IDS              0x0C
#define DESFIRE_GET_FILE_SETTINGS         0x0D
#define DESFIRE_CHANGE_FILE_SETTINGS      0x0E
#define DESFIRE_CREATE_STANDARD_DATA_FILE 0x0F
#define DESFIRE_CREATE_BACKUP_DATA_FILE   0x10
#define DESFIRE_CREATE_VALUE_FILE         0x11
#define DESFIRE_CREATE_LINEAR_RECORD_FILE 0x12
#define DESFIRE_CREATE_CYCLIC_RECORD_FILE 0x13
#define DESFIRE_DELETE_FILE               0x14
#define DESFIRE_READ_DATA                 0x15
#define DESFIRE_READ_RECORDS              0x16
#define DESFIRE_WRITE_DATA                0x17
#define DESFIRE_WRITE_RECORDS             0x18
#define DESFIRE_GET_VALUE                 0x19
#define DESFIRE_CREDIT                    0x1A
#define DESFIRE_DEBIT                     0x1B
#define DESFIRE_LIMITED_CREDIT            0x1C
#define DESFIRE_CLEAR_RECORD_FILE         0x1D
#define DESFIRE_COMMIT_TRANSACTION        0x1E
#define DESFIRE_ABORT_TRANSACTION         0x1F
#define DESFIRE_SET_FILE_SETTINGS         0x20

#define DESFIRE_INIT_PCB_BLOCKNUMBER      0x2F

#define SAM_DISABLE_CRYPTO                0x30
#define SAM_CHANGE_KEY_ENTRY              0x31
#define SAM_GET_KEY_ENTRY                 0x32
#define SAM_CHANGE_KUC_ENTRY              0x33
#define SAM_GET_KUC_ENTRY                 0x34
#define SAM_CHANGE_KEY_PICC               0x35
#define SAM_GET_VERSION                   0x36
#define SAM_AUTHENTICATE_HOST             0x37
#define SAM_SELECT_APPLICATION            0x38
#define SAM_DUMP_SESSION_KEY              0x39
#define SAM_LOAD_INIT_VECTOR              0x3A
#define SAM_AUTHENTICATE_PICC1            0x3B
#define SAM_AUTHENTICATE_PICC2            0x3C
#define SAM_VERIFY_MAC                    0x3D
#define SAM_GENERATE_MAC                  0x3E
#define SAM_DECIPHER_DATA                 0x3F
#define SAM_ENCIPHER_DATA                 0x40
#define SAM_SET_LOGICAL_CHANNEL           0x42
#define SAM_SET_TRANSMISSION_FACTOR       0x43

// Paypass error definitions
#define PAYPASS_ERROR_OK                0x00
#define PAYPASS_ERROR_NOTAG             0x01 // no tag found
#define PAYPASS_ERROR_COLLISION         0x02 // more than one tag found
#define PAYPASS_ERROR_TAGFOUND          0x03 // deactivation not complete, tag found
#define PAYPASS_ERROR                   0x04 // Polling/Activation/Transaction Error

#define PAYPASS_ERROR_READERPOINTER     0x41 // pointer is zero
#define PAYPASS_ERROR_PROTOCOL          0x42 // ascii protocol found
#define PAYPASS_ERROR_READER            0x43 // no MultiISO/Dual found
#define PAYPASS_ERROR_BUFFEROVERFLOW    0x45 // Transaction Receiver Buffer Overflow
