#include "stdafx.h"
#include "DlgConnectionSettings.h"
extern HANDLE hCom;
DWORD baudRates[] = {9600, 19200, 38400,57600,  115200, 230400, 460800, 921600};

INT_PTR CALLBACK ConnectionDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		{
		//Getting port name.
			RefershPorts(GetDlgItem(hDlg,IDC_CMBPORTNAME));
			HWND hwndCmbBaudRate =GetDlgItem(hDlg,IDC_CMBBAUDRATE);
			for(int i=0;i<sizeof(baudRates)/sizeof(DWORD);i++){
			char pcBaudRate[10]={0};
				sprintf_s(pcBaudRate,sizeof(pcBaudRate),"%d",baudRates[i]);
				SendMessage(hwndCmbBaudRate,CB_ADDSTRING,NULL,(LPARAM)pcBaudRate);
			}
			SendMessage(hwndCmbBaudRate,CB_SETCURSEL,0,0);
			hwndCmbBaudRate =GetDlgItem(hDlg,IDC_CMBPROTOCOL);
			SendMessage(hwndCmbBaudRate,CB_ADDSTRING,NULL,(LPARAM)"Bianry");
			SendMessage(hwndCmbBaudRate,CB_ADDSTRING,NULL,(LPARAM)"ASCII");
			SendMessage(hwndCmbBaudRate,CB_SETCURSEL,0,0);
			if(hCom!=INVALID_HANDLE_VALUE && hReader!=INVALID_HANDLE_VALUE){
				SetDlgItemText(hDlg,IDOK,"Disconnect");
			}

		}
		return (INT_PTR)TRUE;
		
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDC_CMDREFERSHCOM:
			RefershPorts(GetDlgItem(hDlg,IDC_CMBPORTNAME));
			break;
		case  IDCANCEL:
		case  IDCANCEL2:
			{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
			}
		case IDOK:
			{
				if(hCom!=INVALID_HANDLE_VALUE && hReader!=INVALID_HANDLE_VALUE){
					RDR_CloseReader(hReader);
					RDR_CloseComm(hCom);
					//RDR_SleepComm(hCom);
					//RDR_WakeupComm(hCom);
					hReader=INVALID_HANDLE_VALUE;
					hCom=INVALID_HANDLE_VALUE;
					SetDlgItemText(hDlg,IDOK,"Connect");
					RefershPorts(GetDlgItem(hDlg,IDC_CMBPORTNAME));
					SetDlgItemText(hDlg,IDC_LAB1,"Disconnected..");
					return 0;
				}
			presetSettings ps;
			BOOL fAutoSelect=TRUE;
			HWND hWndBaudrate=GetDlgItem(hDlg,IDC_CMBBAUDRATE);
			int index=(int)SendMessage(hWndBaudrate,CB_GETCURSEL,0,0);
			ps.baudRate=baudRates[index];
			HWND hWndCmbProtocol=GetDlgItem(hDlg,IDC_CMBPROTOCOL);
			ps.protocol=(int)SendMessage(hWndCmbProtocol,CB_GETCURSEL,0,0);
			HWND hWndChkAutoSelect=GetDlgItem(hDlg,IDC_CHKAUTOSELECT);
			if(SendMessage(hWndChkAutoSelect,BM_GETCHECK,0,0)!=BST_CHECKED){
				fAutoSelect=FALSE;
			}
			HWND hWndCmbPort=GetDlgItem(hDlg,IDC_CMBPORTNAME);
			index=(int)SendMessage(hWndCmbPort,CB_GETCURSEL,0,0);
			char pcCPName[100]={0};
			SendMessage(hWndCmbPort,CB_GETLBTEXT,index,(LPARAM)(LPTSTR)pcCPName);
			hCom=RDR_OpenComm(pcCPName,fAutoSelect,&ps);
			if(fAutoSelect){
				ps.protocol=RDR_GetCommProtocol(hCom);
				ps.baudRate =RDR_GetCommBaudRate(hCom);
			}
			if(hCom){
			ZeroMemory(pcCPName,100);
			RDR_DetectReader(hCom,pcCPName);
			hReader=RDR_OpenReader(hCom,pcCPName[0],0);
			ZeroMemory(pcCPName,100);
			RDR_GetReaderType(hReader,pcCPName);
			RDR_SendCommandGetData(hReader,"Version",pcCPName,pcCPName);
			if(_stricmp(pcCPName,"")!=0){
				SetDlgItemText(hDlg,IDOK,"Disconnect");
				char pchar[MAX_PATH]={"Connected to "};
				strcat(pchar,pcCPName);
				SetDlgItemText(hDlg,IDC_LAB1,pchar);
				if(hCom!=INVALID_HANDLE_VALUE && hReader!=INVALID_HANDLE_VALUE){
					AddLog("Connect successfully");
				}
			}else{
				AddLog("unable to connect");
				SetDlgItemText(hDlg,IDC_LAB1,"Unable to connect");
			}
			}else{
				AddLog("unable to connect");
				SetDlgItemText(hDlg,IDC_LAB1,"Unable to connect");
			}
			}
			break;
		case IDC_CHKAUTOSELECT:
			{
				HWND hwndChkAutoselect =GetDlgItem(hDlg,IDC_CHKAUTOSELECT);
				if(SendMessage(hwndChkAutoselect,BM_GETCHECK,NULL,NULL)==BST_CHECKED){
				HWND hwndCmbBaudRate =GetDlgItem(hDlg,IDC_CMBPROTOCOL);
				EnableWindow(hwndCmbBaudRate,false);
				hwndCmbBaudRate =GetDlgItem(hDlg,IDC_CMBBAUDRATE);
				EnableWindow(hwndCmbBaudRate,false);
				}else{
				HWND hwndCmbBaudRate =GetDlgItem(hDlg,IDC_CMBPROTOCOL);
				EnableWindow(hwndCmbBaudRate,TRUE);
				hwndCmbBaudRate =GetDlgItem(hDlg,IDC_CMBBAUDRATE);
				EnableWindow(hwndCmbBaudRate,TRUE);
				
				}
			}
			break;
		}
		break;
	}
	return (INT_PTR)FALSE;
}
void RefershPorts(HWND cmb){
	SendMessage(cmb,CB_RESETCONTENT,NULL,NULL);
	long nLen=MAX_PATH;
	char retBuff[MAX_PATH]={0};
	if(RDR_DetectSerialPort(retBuff,nLen))
		return ;
	int i=0;
	while(strlen(&retBuff[i])){
		SendMessage(cmb,CB_ADDSTRING,0,(LPARAM)&retBuff[i]);
		i+=strlen(&retBuff[i])+1;
	}
	SendMessage(cmb,CB_SETCURSEL,0,NULL);
}