#include "stdafx.h"
#include "EepromSettingsDlg.h"
#include  ".\Helper\HaxaOperation.h"
#define MAX_TEXT_VALUE 10
#define MAX_BUFFER_LEN 512
void SetRegisterValue(HWND hdlg)
{
	if(hReader==NULL)return;
	char pcTextValue[MAX_TEXT_VALUE]={0};
	GetDlgItemText(hdlg,IDC_REGINDEX,pcTextValue,MAX_TEXT_VALUE);
	char pDataIn[2]={0};
	unsigned int nLenIn=0;
	unsigned int nretBufLen[2]={0};
	Hex2Char(pcTextValue,(unsigned char &)pDataIn[nLenIn++]);
	ZeroMemory(pcTextValue,MAX_TEXT_VALUE);
	GetDlgItemText(hdlg,IDC_REGVALUE,pcTextValue,MAX_TEXT_VALUE);
	Hex2Char(pcTextValue,(unsigned char &)pDataIn[nLenIn++]);
	char retBuffer[MAX_BUFFER_LEN]={0};
	if(hReader!=INVALID_HANDLE_VALUE)
	RDR_SendCommandGetData2(hReader,"wp",pDataIn,nLenIn,retBuffer,nretBufLen);
	if(retBuffer[0]==pDataIn[1] && *nretBufLen>=1){
		SetDlgItemText(hdlg,IDC_LAB1,"Value set successfully");
	}else
		SetDlgItemText(hdlg,IDC_LAB1,"Unable to set value");
}
void GetRegisterValue(HWND hdlg)
{
	if(hReader==NULL)return; 
	char pcTextValue[MAX_TEXT_VALUE]={0};
	GetDlgItemText(hdlg,IDC_REGINDEX,pcTextValue,MAX_TEXT_VALUE);
	char pDataIn[2]={0};
	unsigned int nLenIn=0;
	unsigned int nretBufLen[2]={0};
	Hex2Char(pcTextValue,(unsigned char &)pDataIn[nLenIn++]);
	char retBuffer[MAX_BUFFER_LEN]={0};
	if(hReader!=INVALID_HANDLE_VALUE)
	RDR_SendCommandGetData2(hReader,"rp",pDataIn,nLenIn,retBuffer,(unsigned int *)nretBufLen);
	if(*nretBufLen>0){
		Binary2Hex((unsigned char *)retBuffer,1,&retBuffer[1]);
		SetDlgItemText(hdlg,IDC_REGVALUE,&retBuffer[1]);
		SetDlgItemText(hdlg,IDC_LAB1,"Got it..");
	}else
		SetDlgItemText(hdlg,IDC_LAB1,"Unable to set value");
}
void applyNewSettings(HWND hdlg){
if(hReader==NULL)return; 
	RDR_ResetReader(hReader);

}
INT_PTR CALLBACK EepromSettingDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		{
			EnableWindow(GetDlgItem(hDlg,IDAPPLY),FALSE);
		}
		return (INT_PTR)TRUE;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDCANCEL:
			{
			if(IsWindowEnabled(GetDlgItem(hDlg,IDAPPLY)))
			{
				if(MessageBox(hDlg,"You want to apply new settings?","Register Settings",MB_YESNO)==IDYES){
				applyNewSettings(hDlg);
				}
			}
			EndDialog(hDlg,0);
			return 0;
			}
		case ID_SETVALUE:
			{
				//Get Value from editBox and set it to register.
				SetRegisterValue(hDlg);
				EnableWindow(GetDlgItem(hDlg,IDAPPLY),TRUE);
			}
			break;
		case ID_GETVALUE:
			{
				//GetValue from EEPROM and display in EditBox.
				GetRegisterValue(hDlg);
			}
			break;
		case IDAPPLY:
			{
				//Update values in Register and we need now to reset redear.
				applyNewSettings(hDlg);
				EnableWindow(GetDlgItem(hDlg,IDAPPLY),FALSE);
			}
			break;
		}
		break;
	}
	return (INT_PTR)FALSE;
}
