// ReaderDll_demo_Win32.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "EepromSettingsDlg.h"
#include "ReaderDll_demo_Win32.h"
#include "DlgConnectionSettings.h"

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name
HANDLE hReader=INVALID_HANDLE_VALUE;
HANDLE hCom=INVALID_HANDLE_VALUE;
HWND hEditWindow=NULL;
HWND hWndMain=NULL;
//For Timer
#define READER_TIMER 786
#define TIME_ELAPSE 100
// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

void CALLBACK TimerProc(  HWND hwnd,   UINT uMsg,   UINT idEvent,   DWORD dwTime );
int APIENTRY _tWinMain(HINSTANCE hInstance,
					   HINSTANCE hPrevInstance,
					   LPTSTR    lpCmdLine,
					   int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_READERDLL_DEMO_WIN32, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_READERDLL_DEMO_WIN32));

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_READERDLL_DEMO_WIN32));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_READERDLL_DEMO_WIN32);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HINSTANCE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	HWND hWnd;

	hInst = hInstance; // Store instance handle in our global variable

	hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

	if (!hWnd)
	{
		return FALSE;
	}

	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

	return TRUE;
}

//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message)
	{
	case WM_CREATE:
		{
			hWndMain=hWnd;
			RECT rt;
			GetClientRect(hWnd,&rt);
			hEditWindow=CreateWindow("edit","",WS_CHILDWINDOW|WS_VISIBLE|WS_BORDER/*|ES_READONLY*/|ES_AUTOVSCROLL|ES_MULTILINE|WS_VSCROLL,0,0,rt.right,rt.bottom,hWnd,NULL,hInst,NULL);
			HFONT font= CreateFont( 
				14,                        // nHeight
				0,                         // nWidth
				0,                         // nEscapement
				0,                         // nOrientation
				FW_NORMAL,                 // nWeight
				FALSE,                     // bItalic
				FALSE,                     // bUnderline
				0,                         // cStrikeOut
				ANSI_CHARSET,              // nCharSet
				OUT_DEFAULT_PRECIS,        // nOutPrecision
				CLIP_DEFAULT_PRECIS,       // nClipPrecision
				DEFAULT_QUALITY,           // nQuality
				DEFAULT_PITCH | FF_SWISS,  // nPitchAndFamily
				"corrier new ");
			SendMessage(hEditWindow,WM_SETFONT,(WPARAM)font,TRUE);

		}
		break;
	case WM_SIZE:
		{
			RECT rt;
			GetClientRect(hWnd,&rt);
			SetWindowPos(hEditWindow,NULL,rt.left,rt.top,rt.right,rt.bottom,SWP_SHOWWINDOW);
		}
		break;
	case WM_CTLCOLOREDIT:
		{
		//Setting text Color for edit Box
			if((HWND)lParam==hEditWindow){
				HDC hdcEdit = (HDC)wParam; //Get handles
				SetTextColor(hdcEdit, RGB(0,0,255)); // Text color
			}
		}
		break;
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case IDM_EXIT:
			{
				if(hReader!=INVALID_HANDLE_VALUE)
				RDR_CloseReader(hReader);
				//Closing VCOM port
				if(hCom!=INVALID_HANDLE_VALUE)
				RDR_CloseComm(hCom);
				DestroyWindow(hWnd);
			}
			break;
		case ID_FILE_CONNECT:
			{
				HMENU hMenu=GetMenu(hWndMain);
				DialogBox(hInst, MAKEINTRESOURCE(IDD_CONNECTDLG), hWnd, ConnectionDlgProc);
					
				if(hCom!=INVALID_HANDLE_VALUE && hReader!=INVALID_HANDLE_VALUE){
					EnableMenuItem(hMenu,ID_EEPROM_REGISTER, MF_ENABLED );
					EnableMenuItem(hMenu,ID_FUNCTION_CONT, MF_ENABLED );
					EnableMenuItem(hMenu,ID_FUNCTION_STOPCONT, MF_ENABLED );
					EnableMenuItem(hMenu,ID_FUNCTION_READERINFO, MF_ENABLED );
					EnableMenuItem(hMenu,ID_FUNCTION_SELECTCARD, MF_ENABLED );
					
				}else{
					EnableMenuItem(hMenu,ID_EEPROM_REGISTER, MF_GRAYED);
					EnableMenuItem(hMenu,ID_FUNCTION_CONT, MF_DISABLED );
					EnableMenuItem(hMenu,ID_FUNCTION_STOPCONT, MF_DISABLED);
					EnableMenuItem(hMenu,ID_FUNCTION_READERINFO, MF_DISABLED );
					EnableMenuItem(hMenu,ID_FUNCTION_SELECTCARD, MF_DISABLED );
					
				}
			}
			break;
		case ID_EEPROM_REGISTER:
			{
				//Setting and getting values of differnet regiters.
				DialogBox(hInst, MAKEINTRESOURCE(IDD_REGISTERDLG), hWnd, EepromSettingDlgProc);
			}
			break;
		case ID_FUNCTION_CONT:
			{
			if(hCom!=INVALID_HANDLE_VALUE && hReader!=INVALID_HANDLE_VALUE){
					RDR_EmptyCommRcvBuffer(hCom);
					RDR_SendCommand(hReader,"C","");
					RDR_SetCommContRcv(hCom,1);
					SetTimer(hWnd,READER_TIMER,TIME_ELAPSE,&TimerProc);
				}
			}
			break;
		case ID_FUNCTION_READERINFO:
			{
				if(hCom!=INVALID_HANDLE_VALUE && hReader!=INVALID_HANDLE_VALUE){
					KillTimer(hWnd,READER_TIMER);
					char pchReaderType[MAX_PATH]={0};
					RDR_GetReaderType(hReader,pchReaderType);
					AddLog("Reader Type: ",0);
					AddLog(pchReaderType,0);
					ZeroMemory(pchReaderType,MAX_PATH);
					RDR_GetDeviceID(hReader,pchReaderType);
					AddLog("Reader ID: ",1);
					AddLog(pchReaderType,0);
					ZeroMemory(pchReaderType,MAX_PATH);
					sprintf_s(pchReaderType,MAX_PATH,"Station ID: %04X",RDR_GetStationID(hReader));
					AddLog(pchReaderType,1);
					ZeroMemory(pchReaderType,MAX_PATH);
				}
			}
			break;
		case ID_FUNCTION_SELECTCARD:
			{
			if(hCom!=INVALID_HANDLE_VALUE && hReader!=INVALID_HANDLE_VALUE){
				KillTimer(hWnd,READER_TIMER);
				char pchReaderType[MAX_PATH]={0};
				RDR_SendCommandGetData(hReader,"select","",pchReaderType);
				AddLog(pchReaderType,1);
					
			}
		
			}
			break;
		case ID_FUNCTION_STOPCONT:
			{
			if(hCom!=INVALID_HANDLE_VALUE && hReader!=INVALID_HANDLE_VALUE){
				KillTimer(hWnd,READER_TIMER);
				RDR_SendCommand(hReader,".","");
				RDR_EmptyCommRcvBuffer(hCom);
				RDR_SetCommContRcv(hCom,0);
				RDR_AbortContinuousRead(hCom);
			}
			}
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		{
			hdc = BeginPaint(hWnd, &ps);
			// TODO: Add any drawing code here...

			EndPaint(hWnd, &ps);
		}
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}
void CALLBACK TimerProc(  HWND hwnd,   UINT uMsg,   UINT idEvent,   DWORD dwTime ){
switch(idEvent)
{
case READER_TIMER:
	{
		char pchReaderData[MAX_PATH]={0};
		unsigned int retLen;
		RDR_GetData2(hReader,pchReaderData,&retLen);
		if(retLen>1)
			AddLog(pchReaderData,0);

	}
	break;
default:
	break;
}
}
// Message handler for about box.
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		{
			char pchVersion[MAX_PATH]={"Reader Dll Version "};
			RDR_GetDLLVersionStr(& pchVersion[strlen(pchVersion)]);
			SetDlgItemText(hDlg,IDC_DLL_VERSION,pchVersion);
		}
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}

void AddLog(char *pcValue,bool CrLf){
	
	if(CrLf){
		SendMessage(hEditWindow,EM_REPLACESEL,(WPARAM)TRUE,(LPARAM)(LPCTSTR)"\r\n");
		SendMessage(hEditWindow,EM_REPLACESEL,(WPARAM)TRUE,(LPARAM)(LPCTSTR)pcValue);
	}else{
		SendMessage(hEditWindow,EM_REPLACESEL,(WPARAM)TRUE,(LPARAM)(LPCTSTR)pcValue);
	}
}